<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.6.0_65) on Wed Jun 25 14:23:49 JST 2014 -->
<TITLE>
NIOServerCnxn
</TITLE>

<META NAME="date" CONTENT="2014-06-25">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    if (location.href.indexOf('is-external=true') == -1) {
        parent.document.title="NIOServerCnxn";
    }
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">
<HR>


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../org/apache/zookeeper/server/NettyServerCnxnFactory.html" title="class in org.apache.zookeeper.server"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxnFactory.html" title="class in org.apache.zookeeper.server"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?org/apache/zookeeper/server/NIOServerCnxn.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="NIOServerCnxn.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;<A HREF="#nested_classes_inherited_from_class_org.apache.zookeeper.server.ServerCnxn">NESTED</A>&nbsp;|&nbsp;<A HREF="#fields_inherited_from_class_org.apache.zookeeper.server.ServerCnxn">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
org.apache.zookeeper.server</FONT>
<BR>
Class NIOServerCnxn</H2>
<PRE>
java.lang.Object
  <IMG SRC="../../../../resources/inherit.gif" ALT="extended by "><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html" title="class in org.apache.zookeeper.server">org.apache.zookeeper.server.ServerCnxn</A>
      <IMG SRC="../../../../resources/inherit.gif" ALT="extended by "><B>org.apache.zookeeper.server.NIOServerCnxn</B>
</PRE>
<DL>
<DT><B>All Implemented Interfaces:</B> <DD><A HREF="../../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A></DD>
</DL>
<HR>
<DL>
<DT><PRE>public class <B>NIOServerCnxn</B><DT>extends <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html" title="class in org.apache.zookeeper.server">ServerCnxn</A></DL>
</PRE>

<P>
This class handles communication with clients using NIO. There is one per
 client, but only one thread doing the communication.
<P>

<P>
<HR>

<P>
<!-- ======== NESTED CLASS SUMMARY ======== -->

<A NAME="nested_class_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Nested Class Summary</B></FONT></TH>
</TR>
</TABLE>
&nbsp;<A NAME="nested_classes_inherited_from_class_org.apache.zookeeper.server.ServerCnxn"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Nested classes/interfaces inherited from class org.apache.zookeeper.server.<A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html" title="class in org.apache.zookeeper.server">ServerCnxn</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.CloseRequestException.html" title="class in org.apache.zookeeper.server">ServerCnxn.CloseRequestException</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.EndOfStreamException.html" title="class in org.apache.zookeeper.server">ServerCnxn.EndOfStreamException</A></CODE></TD>
</TR>
</TABLE>
&nbsp;
<A NAME="nested_classes_inherited_from_class_org.apache.zookeeper.Watcher"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Nested classes/interfaces inherited from interface org.apache.zookeeper.<A HREF="../../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="../../../../org/apache/zookeeper/Watcher.Event.html" title="interface in org.apache.zookeeper">Watcher.Event</A></CODE></TD>
</TR>
</TABLE>
&nbsp;
<!-- =========== FIELD SUMMARY =========== -->

<A NAME="field_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Field Summary</B></FONT></TH>
</TR>
</TABLE>
&nbsp;<A NAME="fields_inherited_from_class_org.apache.zookeeper.server.ServerCnxn"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Fields inherited from class org.apache.zookeeper.server.<A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html" title="class in org.apache.zookeeper.server">ServerCnxn</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#authInfo">authInfo</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#cmd2String">cmd2String</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#confCmd">confCmd</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#consCmd">consCmd</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#count">count</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#crstCmd">crstCmd</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#dumpCmd">dumpCmd</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#enviCmd">enviCmd</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#established">established</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#getTraceMaskCmd">getTraceMaskCmd</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#isroCmd">isroCmd</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#lastCxid">lastCxid</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#lastLatency">lastLatency</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#lastOp">lastOp</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#lastResponseTime">lastResponseTime</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#lastZxid">lastZxid</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#maxLatency">maxLatency</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#me">me</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#minLatency">minLatency</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#mntrCmd">mntrCmd</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#packetsReceived">packetsReceived</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#packetsSent">packetsSent</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#ruokCmd">ruokCmd</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#setTraceMaskCmd">setTraceMaskCmd</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#srstCmd">srstCmd</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#srvrCmd">srvrCmd</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#statCmd">statCmd</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#totalLatency">totalLatency</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#wchcCmd">wchcCmd</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#wchpCmd">wchpCmd</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#wchsCmd">wchsCmd</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#zooKeeperSaslServer">zooKeeperSaslServer</A></CODE></TD>
</TR>
</TABLE>
&nbsp;
<!-- ======== CONSTRUCTOR SUMMARY ======== -->

<A NAME="constructor_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Constructor Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#NIOServerCnxn(org.apache.zookeeper.server.ZooKeeperServer, java.nio.channels.SocketChannel, java.nio.channels.SelectionKey, org.apache.zookeeper.server.NIOServerCnxnFactory)">NIOServerCnxn</A></B>(<A HREF="../../../../org/apache/zookeeper/server/ZooKeeperServer.html" title="class in org.apache.zookeeper.server">ZooKeeperServer</A>&nbsp;zk,
              java.nio.channels.SocketChannel&nbsp;sock,
              java.nio.channels.SelectionKey&nbsp;sk,
              <A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxnFactory.html" title="class in org.apache.zookeeper.server">NIOServerCnxnFactory</A>&nbsp;factory)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
</TABLE>
&nbsp;
<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#close()">close</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#disableRecv()">disableRecv</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#enableRecv()">enableRecv</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#getInterestOps()">getInterestOps</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#getOutstandingRequests()">getOutstandingRequests</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;The number of requests that have been submitted but not yet
 responded to.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.net.InetSocketAddress</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#getRemoteSocketAddress()">getRemoteSocketAddress</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;long</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#getSessionId()">getSessionId</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;int</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#getSessionTimeout()">getSessionTimeout</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#incrOutstandingRequests(RequestHeader)">incrOutstandingRequests</A></B>(RequestHeader&nbsp;h)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;boolean</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#isSocketOpen()">isSocketOpen</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Only used in order to allow testing</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#process(org.apache.zookeeper.WatchedEvent)">process</A></B>(<A HREF="../../../../org/apache/zookeeper/WatchedEvent.html" title="class in org.apache.zookeeper">WatchedEvent</A>&nbsp;event)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#sendBuffer(java.nio.ByteBuffer)">sendBuffer</A></B>(java.nio.ByteBuffer&nbsp;bb)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#sendCloseSession()">sendCloseSession</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#sendResponse(ReplyHeader, org.apache.jute.Record, java.lang.String)">sendResponse</A></B>(ReplyHeader&nbsp;h,
             org.apache.jute.Record&nbsp;r,
             java.lang.String&nbsp;tag)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>protected &nbsp;<A HREF="../../../../org/apache/zookeeper/server/ServerStats.html" title="class in org.apache.zookeeper.server">ServerStats</A></CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#serverStats()">serverStats</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#setSessionId(long)">setSessionId</A></B>(long&nbsp;sessionId)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;void</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#setSessionTimeout(int)">setSessionTimeout</A></B>(int&nbsp;sessionTimeout)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>&nbsp;java.lang.String</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxn.html#toString()">toString</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Prints detailed stats information for the connection.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_org.apache.zookeeper.server.ServerCnxn"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class org.apache.zookeeper.server.<A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html" title="class in org.apache.zookeeper.server">ServerCnxn</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#addAuthInfo(Id)">addAuthInfo</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#dumpConnectionInfo(java.io.PrintWriter, boolean)">dumpConnectionInfo</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#getAuthInfo()">getAuthInfo</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#getAvgLatency()">getAvgLatency</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#getEstablished()">getEstablished</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#getLastCxid()">getLastCxid</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#getLastLatency()">getLastLatency</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#getLastOperation()">getLastOperation</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#getLastResponseTime()">getLastResponseTime</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#getLastZxid()">getLastZxid</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#getMaxLatency()">getMaxLatency</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#getMinLatency()">getMinLatency</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#getPacketsReceived()">getPacketsReceived</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#getPacketsSent()">getPacketsSent</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#incrPacketsReceived()">incrPacketsReceived</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#incrPacketsSent()">incrPacketsSent</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#packetReceived()">packetReceived</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#packetSent()">packetSent</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#removeAuthInfo(Id)">removeAuthInfo</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#resetStats()">resetStats</A>, <A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#updateStatsForResponse(long, long, java.lang.String, long, long)">updateStatsForResponse</A></CODE></TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.Object</B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE>clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait</CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ========= CONSTRUCTOR DETAIL ======== -->

<A NAME="constructor_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Constructor Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="NIOServerCnxn(org.apache.zookeeper.server.ZooKeeperServer, java.nio.channels.SocketChannel, java.nio.channels.SelectionKey, org.apache.zookeeper.server.NIOServerCnxnFactory)"><!-- --></A><H3>
NIOServerCnxn</H3>
<PRE>
public <B>NIOServerCnxn</B>(<A HREF="../../../../org/apache/zookeeper/server/ZooKeeperServer.html" title="class in org.apache.zookeeper.server">ZooKeeperServer</A>&nbsp;zk,
                     java.nio.channels.SocketChannel&nbsp;sock,
                     java.nio.channels.SelectionKey&nbsp;sk,
                     <A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxnFactory.html" title="class in org.apache.zookeeper.server">NIOServerCnxnFactory</A>&nbsp;factory)
              throws java.io.IOException</PRE>
<DL>
<DL>

<DT><B>Throws:</B>
<DD><CODE>java.io.IOException</CODE></DL>
</DL>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="sendCloseSession()"><!-- --></A><H3>
sendCloseSession</H3>
<PRE>
public void <B>sendCloseSession</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="sendBuffer(java.nio.ByteBuffer)"><!-- --></A><H3>
sendBuffer</H3>
<PRE>
public void <B>sendBuffer</B>(java.nio.ByteBuffer&nbsp;bb)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="isSocketOpen()"><!-- --></A><H3>
isSocketOpen</H3>
<PRE>
protected boolean <B>isSocketOpen</B>()</PRE>
<DL>
<DD>Only used in order to allow testing
<P>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="incrOutstandingRequests(RequestHeader)"><!-- --></A><H3>
incrOutstandingRequests</H3>
<PRE>
protected void <B>incrOutstandingRequests</B>(RequestHeader&nbsp;h)</PRE>
<DL>
<DD><DL>
<DT><B>Overrides:</B><DD><CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#incrOutstandingRequests(RequestHeader)">incrOutstandingRequests</A></CODE> in class <CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html" title="class in org.apache.zookeeper.server">ServerCnxn</A></CODE></DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="disableRecv()"><!-- --></A><H3>
disableRecv</H3>
<PRE>
public void <B>disableRecv</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="enableRecv()"><!-- --></A><H3>
enableRecv</H3>
<PRE>
public void <B>enableRecv</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getOutstandingRequests()"><!-- --></A><H3>
getOutstandingRequests</H3>
<PRE>
public long <B>getOutstandingRequests</B>()</PRE>
<DL>
<DD>The number of requests that have been submitted but not yet
 responded to.
<P>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#getOutstandingRequests()">getOutstandingRequests</A></CODE> in class <CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html" title="class in org.apache.zookeeper.server">ServerCnxn</A></CODE></DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getSessionTimeout()"><!-- --></A><H3>
getSessionTimeout</H3>
<PRE>
public int <B>getSessionTimeout</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="toString()"><!-- --></A><H3>
toString</H3>
<PRE>
public java.lang.String <B>toString</B>()</PRE>
<DL>
<DD><B>Description copied from class: <CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#toString()">ServerCnxn</A></CODE></B></DD>
<DD>Prints detailed stats information for the connection.
<P>
<DD><DL>
<DT><B>Overrides:</B><DD><CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#toString()">toString</A></CODE> in class <CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html" title="class in org.apache.zookeeper.server">ServerCnxn</A></CODE></DL>
</DD>
<DD><DL>
<DT><B>See Also:</B><DD><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#dumpConnectionInfo(java.io.PrintWriter, boolean)"><CODE>for brief stats</CODE></A></DL>
</DD>
</DL>
<HR>

<A NAME="close()"><!-- --></A><H3>
close</H3>
<PRE>
public void <B>close</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="sendResponse(ReplyHeader, org.apache.jute.Record, java.lang.String)"><!-- --></A><H3>
sendResponse</H3>
<PRE>
public void <B>sendResponse</B>(ReplyHeader&nbsp;h,
                         org.apache.jute.Record&nbsp;r,
                         java.lang.String&nbsp;tag)</PRE>
<DL>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#sendResponse(ReplyHeader, org.apache.jute.Record, java.lang.String)">sendResponse</A></CODE> in class <CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html" title="class in org.apache.zookeeper.server">ServerCnxn</A></CODE></DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="process(org.apache.zookeeper.WatchedEvent)"><!-- --></A><H3>
process</H3>
<PRE>
public void <B>process</B>(<A HREF="../../../../org/apache/zookeeper/WatchedEvent.html" title="class in org.apache.zookeeper">WatchedEvent</A>&nbsp;event)</PRE>
<DL>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../org/apache/zookeeper/Watcher.html#process(org.apache.zookeeper.WatchedEvent)">process</A></CODE> in interface <CODE><A HREF="../../../../org/apache/zookeeper/Watcher.html" title="interface in org.apache.zookeeper">Watcher</A></CODE><DT><B>Specified by:</B><DD><CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#process(org.apache.zookeeper.WatchedEvent)">process</A></CODE> in class <CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html" title="class in org.apache.zookeeper.server">ServerCnxn</A></CODE></DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getSessionId()"><!-- --></A><H3>
getSessionId</H3>
<PRE>
public long <B>getSessionId</B>()</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setSessionId(long)"><!-- --></A><H3>
setSessionId</H3>
<PRE>
public void <B>setSessionId</B>(long&nbsp;sessionId)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="setSessionTimeout(int)"><!-- --></A><H3>
setSessionTimeout</H3>
<PRE>
public void <B>setSessionTimeout</B>(int&nbsp;sessionTimeout)</PRE>
<DL>
<DD><DL>
</DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getInterestOps()"><!-- --></A><H3>
getInterestOps</H3>
<PRE>
public int <B>getInterestOps</B>()</PRE>
<DL>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#getInterestOps()">getInterestOps</A></CODE> in class <CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html" title="class in org.apache.zookeeper.server">ServerCnxn</A></CODE></DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="getRemoteSocketAddress()"><!-- --></A><H3>
getRemoteSocketAddress</H3>
<PRE>
public java.net.InetSocketAddress <B>getRemoteSocketAddress</B>()</PRE>
<DL>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#getRemoteSocketAddress()">getRemoteSocketAddress</A></CODE> in class <CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html" title="class in org.apache.zookeeper.server">ServerCnxn</A></CODE></DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<HR>

<A NAME="serverStats()"><!-- --></A><H3>
serverStats</H3>
<PRE>
protected <A HREF="../../../../org/apache/zookeeper/server/ServerStats.html" title="class in org.apache.zookeeper.server">ServerStats</A> <B>serverStats</B>()</PRE>
<DL>
<DD><DL>
<DT><B>Specified by:</B><DD><CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html#serverStats()">serverStats</A></CODE> in class <CODE><A HREF="../../../../org/apache/zookeeper/server/ServerCnxn.html" title="class in org.apache.zookeeper.server">ServerCnxn</A></CODE></DL>
</DD>
<DD><DL>
</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../org/apache/zookeeper/server/NettyServerCnxnFactory.html" title="class in org.apache.zookeeper.server"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../org/apache/zookeeper/server/NIOServerCnxnFactory.html" title="class in org.apache.zookeeper.server"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?org/apache/zookeeper/server/NIOServerCnxn.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="NIOServerCnxn.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;<A HREF="#nested_classes_inherited_from_class_org.apache.zookeeper.server.ServerCnxn">NESTED</A>&nbsp;|&nbsp;<A HREF="#fields_inherited_from_class_org.apache.zookeeper.server.ServerCnxn">FIELD</A>&nbsp;|&nbsp;<A HREF="#constructor_summary">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;<A HREF="#constructor_detail">CONSTR</A>&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
